#include "dg2313w.h"
dg2313w::dg2313w (OneWire &wire){
  this->wire = &wire;
}

bool dg2313w::power (bool enable){
  return set (PORT_POWER,enable);
}
bool dg2313w::set (byte address,byte value){
    byte buf[3]={address,value,0};
    byte lcrc = wire->crc8(buf,2);

  if (connect ()){
    wire->write (WRITE_ROM); 
    delayMicroseconds(15);
    wire->write (address);
    wire->write (value);  
    wire->write (lcrc);
  } else return false;
  if (connect ()){
    wire->write (READ_ROM);
    delayMicroseconds(15); 
    wire->write (address);
    delayMicroseconds(60);
    if (wire->read ()!= address) return false;
    if (wire->read ()!= value)   return false;
    if (wire->read ()!= lcrc)    return false;
  } else return false;
  
  return true;
}
bool dg2313w::get (byte address,byte &value){
    byte buf[3]={address,value,0};
    if (connect ()){
      wire->write (READ_ROM);
      delayMicroseconds(15); 
      wire->write (address);
      delayMicroseconds(60);
      if (wire->read ()!= address) return false;
      buf[1] = wire->read ();
      buf[2] = wire->read ();
      byte lcrc = wire->crc8(buf,2);
      value = buf[1];
      if (lcrc == buf[2]) return true;      
  } 
  return false;
}
void dg2313w::select (byte* addr){
    skip = false;
    for (byte i=0;i<8;i++){
      current[i] = addr[i];  
    }
}
bool dg2313w::connect (){
   if (wire->reset ()){
       if (skip)
          wire->skip ();        
        else
          wire->select (current); 
      return true;
   }else return false;
}
 bool dg2313w::readROM (byte* addr){
      if (wire->reset ()){
          wire->write (0x33);
      }
      for (byte i=0;i<8;i++){
        addr[i] = wire->read ();
    }
    byte lcrc = wire->crc8(addr,7);
    if (lcrc==addr[7])
      return true;
      else
      return false;
 }
